package adresare;

import javax.swing.*;
import javax.swing.tree.*;
import java.io.*;

public class Window extends javax.swing.JFrame {

    DefaultTreeModel m;
    MyNode root;
    
    public Window() {
        initComponents();
        String s = "c:\\Program Files";
        root = new MyNode (s);
        root.path = s;
        m = new DefaultTreeModel (root);
        jTree1.setModel (m);
        showDir (root, root.path, 2);
    }

    private void showDir (MyNode above, String path, int level)
    {
        // import java.io.*;
        File dir = new File (path);
        String [] list = dir.list ();
        above.scanned = true; 
        // for (int i = 0; i < list.length; i++)
        if (list != null)
            for (String s : list)
            {
                MyNode node = new MyNode (s);
                node.path = path + File.separator + s;
                above.add(node);
                
                if (level > 1)
                {
                   File f = new File (node.path);
                   if (f.isDirectory())
                      showDir (node, node.path, level-1);
                }
            }
        m.reload(above);
    }

    private void rescanDir (MyNode above, int level)
    {
        if (above.scanned)
        {
            if (level > 1)
            {
                int cnt = above.getChildCount();
                for (int i = 0; i < cnt; i++)
                {
                    TreeNode tn = above.getChildAt (i);
                    if (tn instanceof MyNode)
                    {
                        MyNode node = (MyNode) tn;
                        rescanDir (node, level-1);
                    }
                }
            }
        }
        else
        {
            showDir (above, above.path, level);
        }
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jTree1.addTreeWillExpandListener(new javax.swing.event.TreeWillExpandListener() {
            public void treeWillCollapse(javax.swing.event.TreeExpansionEvent evt)throws javax.swing.tree.ExpandVetoException {
            }
            public void treeWillExpand(javax.swing.event.TreeExpansionEvent evt)throws javax.swing.tree.ExpandVetoException {
                jTree1TreeWillExpand(evt);
            }
        });
        jScrollPane1.setViewportView(jTree1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 325, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(521, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 360, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTree1TreeWillExpand(javax.swing.event.TreeExpansionEvent evt)throws javax.swing.tree.ExpandVetoException {//GEN-FIRST:event_jTree1TreeWillExpand
        Object obj = evt.getPath().getLastPathComponent();
        // setTitle (obj.getClass().getName () + " : " + obj);
        if (obj instanceof MyNode)
        {
           MyNode node = (MyNode) obj;
           rescanDir (node, 2);
        }
    }//GEN-LAST:event_jTree1TreeWillExpand

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Window().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables
}
